/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.battle.BattleEndHandler
 *  fire.pb.battle.PNewBattle
 *  fire.pb.common.SCommon
 *  fire.pb.fanpai.PReqCardProc
 *  fire.pb.main.ConfigManager
 *  fire.pb.map.Role
 *  fire.pb.map.RoleManager
 *  fire.pb.map.SceneNpcManager
 *  fire.pb.mission.SLineTask
 *  fire.pb.mission.SLineTaskConfig
 *  fire.pb.mission.SLineTaskFight
 *  fire.pb.mission.instance.InstanceManager
 *  fire.pb.npc.SPingJi
 *  fire.pb.talk.MessageMgr
 *  fire.pb.team.Team
 *  fire.pb.team.TeamManager
 *  mkdb.Lockey
 *  mkdb.Lockeys
 *  mkdb.Mkdb
 *  mkdb.Procedure
 *  mkdb.TTable
 *  mkio.Protocol
 *  xbean.InstanceInfo
 *  xbean.InstanceInfoCol
 *  xbean.InstanceNpcInfo
 *  xbean.InstanceTaskInfo
 *  xtable.Instancetask
 *  xtable.Locks
 *  xtable.Roleinstancetask
 */
package fire.pb.mission.instance.line;

import fire.pb.battle.BattleEndHandler;
import fire.pb.battle.PNewBattle;
import fire.pb.common.SCommon;
import fire.pb.fanpai.PReqCardProc;
import fire.pb.main.ConfigManager;
import fire.pb.map.Role;
import fire.pb.map.RoleManager;
import fire.pb.map.SceneNpcManager;
import fire.pb.mission.SLineTask;
import fire.pb.mission.SLineTaskConfig;
import fire.pb.mission.SLineTaskFight;
import fire.pb.mission.instance.InstanceManager;
import fire.pb.mission.instance.line.LineBattleEndHandler;
import fire.pb.mission.instance.line.LineEndTimer;
import fire.pb.mission.instance.line.LineInstManager;
import fire.pb.npc.SPingJi;
import fire.pb.talk.MessageMgr;
import fire.pb.team.Team;
import fire.pb.team.TeamManager;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Set;
import java.util.concurrent.TimeUnit;
import mkdb.Lockey;
import mkdb.Lockeys;
import mkdb.Mkdb;
import mkdb.Procedure;
import mkdb.TTable;
import mkio.Protocol;
import xbean.InstanceInfo;
import xbean.InstanceInfoCol;
import xbean.InstanceNpcInfo;
import xbean.InstanceTaskInfo;
import xtable.Instancetask;
import xtable.Locks;
import xtable.Roleinstancetask;

public class PGiveLineProc
extends Procedure {
    private final long roleid;
    private final long npckey;
    private final int serviceId;

    public PGiveLineProc(long roleid, long npckey, int serviceId) {
        this.roleid = roleid;
        this.npckey = npckey;
        this.serviceId = serviceId;
    }

    protected boolean process() throws Exception {
        Team team = TeamManager.getTeamByRoleId((long)this.roleid);
        if (team == null) {
            return false;
        }
        ArrayList allRoleIDs = new ArrayList();
        allRoleIDs.addAll(team.getNormalMemberIds());
        Lockeys.lock((Lockey[])Lockeys.get((TTable)Locks.ROLELOCK, allRoleIDs));
        int instanceId = LineInstManager.getInstance().getInstanceIdByServiceId(this.serviceId);
        if (instanceId == -1) {
            return false;
        }
        InstanceInfoCol taskInfo = Roleinstancetask.select((Long)this.roleid);
        if (taskInfo == null) {
            MessageMgr.psendMsgNotifyWhileRollback((long)this.roleid, (int)144838, null);
            return false;
        }
        InstanceTaskInfo info = (InstanceTaskInfo)taskInfo.getInstinfo().get(instanceId);
        if (info == null) {
            MessageMgr.psendMsgNotifyWhileRollback((long)this.roleid, (int)144838, null);
            return false;
        }
        long taskId = info.getInstanceonlyid();
        InstanceInfo instInfo = Instancetask.get((Long)taskId);
        if (instInfo == null) {
            MessageMgr.psendMsgNotifyWhileRollback((long)this.roleid, (int)144838, null);
            return false;
        }
        instInfo.setServiceid(this.serviceId);
        Role mapRole = RoleManager.getInstance().getRoleByID(this.roleid);
        if (mapRole == null) {
            return false;
        }
        long currentScenceId = mapRole.getScene();
        if (!this.check(instInfo, taskId, currentScenceId, instanceId)) {
            return false;
        }
        SLineTaskFight fightCnf = LineInstManager.getInstance().getFightConfig(this.serviceId);
        if (fightCnf == null) {
            return false;
        }
        int battleid = LineInstManager.getInstance().getFightId(this.serviceId);
        if (battleid == 0) {
            int step = instInfo.getCurrentstep();
            for (InstanceNpcInfo info1 : instInfo.getAsistnpcs()) {
                if (info1.getNpckey() <= 0L) continue;
                SceneNpcManager.premoveNpcWhileCommit((long)info1.getNpckey());
            }
            instInfo.getAsistnpcs().clear();
            List<SLineTaskConfig> stepTaskList = LineInstManager.getInstance().getStepTask(instInfo.getInstanceid(), step + 1);
            if (stepTaskList.size() == 0) {
                for (InstanceNpcInfo npcInfo : instInfo.getNpcs()) {
                    SceneNpcManager.premoveNpcWhileCommit((long)npcInfo.getNpckey());
                }
                this.InstanceEnd(instInfo, instanceId, info.getInstanceonlyid(), 1, 1);
            } else {
                this.instanceEndOneStep(instInfo, 1);
                LineInstManager.getInstance().createInstanceNpc(instInfo, stepTaskList, info.getInstanceonlyid());
                SLineTaskConfig config = stepTaskList.get(0);
                instInfo.setCurrentstep(step + 1);
                instInfo.setCurrenttaskid(config.getTaskid());
                instInfo.setCurrentstate(4);
                LineInstManager.getInstance().addStep1Task(instInfo);
            }
        } else {
            LineBattleEndHandler handler = new LineBattleEndHandler(this.serviceId, this.npckey, info.getInstanceonlyid(), instanceId, fightCnf.awardtimes, fightCnf.yuanzhuawardtimes, fightCnf.award, fightCnf.yuanzhuawardid, fightCnf.itemawardid);
            PNewBattle battle = new PNewBattle(this.roleid, battleid, (BattleEndHandler)handler);
            battle.setBattleType(40);
            return battle.call();
        }
        return true;
    }

    private boolean check(InstanceInfo instInfo, long instOnlyId, long scenceId, int instanceId) {
        SLineTask taskCofig = LineInstManager.getInstance().getInstanceTask(instanceId);
        if (taskCofig == null) {
            return false;
        }
        int tasktypeid = instInfo.getInstanceid();
        int mapId = LineInstManager.getInstance().getMapIdByTaskType(tasktypeid, instInfo.getCurrentstep());
        if (mapId == -1) {
            return false;
        }
        if (!LineInstManager.getInstance().isSameDynamicScene(scenceId, instOnlyId, mapId)) {
            MessageMgr.psendMsgNotifyWhileRollback((long)this.roleid, (int)144839, null);
            return false;
        }
        Team team = TeamManager.selectTeamByRoleId((long)this.roleid);
        if (team == null) {
            MessageMgr.psendMsgNotifyWhileRollback((long)this.roleid, (int)144840, null);
            return false;
        }
        if (team.getTeamLeaderId() != this.roleid) {
            MessageMgr.psendMsgNotifyWhileRollback((long)this.roleid, (int)144841, null);
            return false;
        }
        ArrayList allRoleIDs = new ArrayList();
        allRoleIDs.addAll(team.getNormalMemberIds());
        int count = 0;
        for (Long roleId : allRoleIDs) {
            InstanceTaskInfo info;
            InstanceInfoCol taskInfo = Roleinstancetask.select((Long)roleId);
            if (taskInfo == null || (info = (InstanceTaskInfo)taskInfo.getInstinfo().get(instanceId)).getInstanceonlyid() != instOnlyId) continue;
            ++count;
        }
        if (count < taskCofig.getTeamnum()) {
            MessageMgr.psendMsgNotifyWhileRollback((long)this.roleid, (int)144840, null);
            return false;
        }
        return true;
    }

    public void pingfen(InstanceInfo instInfo, long roleId, int instanceId) {
        SLineTask taskCofig = LineInstManager.getInstance().getInstanceTask(instanceId);
        if (taskCofig == null) {
            return;
        }
        InstanceInfoCol infoCol = Roleinstancetask.select((Long)roleId);
        if (infoCol == null) {
            return;
        }
        InstanceTaskInfo info = (InstanceTaskInfo)infoCol.getInstinfo().get(infoCol.getLastinstanceid());
        if (info == null) {
            return;
        }
        int totalRound = instInfo.getFinalcounts();
        int grade = LineInstManager.getInstance().getGradeByRound(totalRound, instanceId);
        if (grade < 1) {
            return;
        }
        int fanPaiId = LineInstManager.getInstance().getFanPaiId(instanceId, grade);
        if (fanPaiId == 0) {
            return;
        }
        boolean send = new PReqCardProc(roleId, fanPaiId, 4).call();
        if (send) {
            SPingJi pingji = new SPingJi();
            pingji.exp = 0;
            pingji.grade = (byte)grade;
            Procedure.psendWhileCommit((long)roleId, (Protocol)pingji);
        }
    }

    private void InstanceEnd(InstanceInfo instInfo, int instanceId, long instanceOnlyId, int taskState, int state) {
        Set roleids = instInfo.getRoleids();
        Iterator iterator = roleids.iterator();
        while (iterator.hasNext()) {
            long roleid = (Long)iterator.next();
            InstanceInfoCol taskInfo = Roleinstancetask.get((Long)roleid);
            if (taskInfo == null) continue;
            InstanceTaskInfo info = (InstanceTaskInfo)taskInfo.getInstinfo().get(instanceId);
            if (info != null) {
                info.setInstanceflag(taskState);
                info.setState(2);
                info.setCurrentstep(1);
            }
            LineInstManager.getInstance().refreshTaskState(roleid, instInfo.getCurrenttaskid(), state);
        }
        SCommon common = (SCommon)ConfigManager.getInstance().getConf(SCommon.class).get(231);
        int commonCnt = Integer.parseInt(common.getValue());
        if (taskState == 1) {
            for (Long rid : roleids) {
                InstanceInfoCol infoCol = Roleinstancetask.select((Long)rid);
                if (infoCol.getCounts() > commonCnt || infoCol.getFanpai() != 1) continue;
                this.pingfen(instInfo, rid, instanceId);
            }
        }
        Mkdb.executor().schedule((Runnable)new LineEndTimer(instanceOnlyId), 15L, TimeUnit.SECONDS);
    }

    private void instanceEndOneStep(InstanceInfo instInfo, int state) {
        instInfo.setCurrentstate(state);
        Set roleids = instInfo.getRoleids();
        Iterator iterator = roleids.iterator();
        while (iterator.hasNext()) {
            long roleid = (Long)iterator.next();
            InstanceManager.getInstance().refreshTaskState(roleid, instInfo.getCurrenttaskid(), state);
        }
    }
}

